# VectorNav C++ Library: vn::sensors::CompositeData Class Reference

vn::sensors::CompositeData Class Reference

Composite structure of all data types available from VectorNav sensors. More...

`#include <compositedata.h>`

## Public Member Functions

| CompositeData (const CompositeData &cd)
CompositeData & | operator= (const CompositeData &RHS)
void | reset ()
| Resets the data contained in the CompositeData object.
bool | hasAnyAttitude ()
| Indicates if `anyAttitude` has valid data. More...
math::AttitudeF | anyAttitude ()
| Gets and converts the latest attitude data regardless of the received underlying type. Based on which type of attitude data that was last received and processed, this value may be based on either received yaw, pitch, roll, quaternion, or direction cosine matrix data. More...
bool | hasYawPitchRoll ()
| Indicates if `yawPitchRoll` has valid data. More...
math::vec3f | yawPitchRoll ()
| Yaw, pitch, roll data. More...
bool | hasQuaternion ()
| Indicates if `quaternion` has valid data. More...
math::vec4f | quaternion ()
| Quaternion data. More...
bool | hasDirectionCosineMatrix ()
| Indicates if `directionCosineMatrix` has valid data. More...
math::mat3f | directionCosineMatrix ()
| Direction cosine matrix data. More...
bool | hasAnyMagnetic ()
| Indicates if `anyMagnetic` has valid data. More...
math::vec3f | anyMagnetic ()
| Gets and converts the latest magnetic data regardless of the received underlying type. Based on which type of magnetic data that was last received and processed, this value may be based on either received magnetic or magneticUncompensated data. More...
bool | hasMagnetic ()
| Indicates if `magnetic` has valid data. More...
math::vec3f | magnetic ()
| Magnetic data. More...
bool | hasMagneticUncompensated ()
| Indicates if `magneticUncompensated` has valid data. More...
math::vec3f | magneticUncompensated ()
| Magnetic uncompensated data. More...
bool | hasMagneticNed ()
| Indicates if `magneticNed` has valid data. More...
math::vec3f | magneticNed ()
| Magnetic NED data. More...
bool | hasMagneticEcef ()
| Indicates if `magneticEcef` has valid data. More...
math::vec3f | magneticEcef ()
| Magnetic ECEF data. More...
bool | hasAnyAcceleration ()
| Indicates if `anyAcceleration` has valid data. More...
math::vec3f | anyAcceleration ()
| Gets and converts the latest acceleration data regardless of the received underlying type. More...
bool | hasAcceleration ()
| Indicates if `acceleration` has valid data. More...
math::vec3f | acceleration ()
| Acceleration data. More...
bool | hasAccelerationLinearBody ()
| Indicates if `accelerationLinearBody` has valid data. More...
math::vec3f | accelerationLinearBody ()
| Acceleration linear body data. More...
bool | hasAccelerationUncompensated ()
| Indicates if `accelerationUncompensated` has valid data. More...
math::vec3f | accelerationUncompensated ()
| Acceleration uncompensated data. More...
bool | hasAccelerationLinearNed ()
| Indicates if `accelerationLinearNed` has valid data. More...
math::vec3f | accelerationLinearNed ()
| Acceleration linear NED data. More...
bool | hasAccelerationLinearEcef ()
| Indicates if `accelerationLinearEcef` has valid data. More...
math::vec3f | accelerationLinearEcef ()
| Acceleration linear ECEF data. More...
bool | hasAccelerationNed ()
| Indicates if `accelerationNed` has valid data. More...
math::vec3f | accelerationNed ()
| Acceleration NED data. More...
bool | hasAccelerationEcef ()
| Indicates if `accelerationEcef` has valid data. More...
math::vec3f | accelerationEcef ()
| Acceleration ECEF data. More...
bool | hasAnyAngularRate ()
| Indicates if `anyAngularRate` has valid data. More...
math::vec3f | anyAngularRate ()
| Gets and converts the latest angular rate data regardless of the received underlying type. More...
bool | hasAngularRate ()
| Indicates if `angularRate` has valid data. More...
math::vec3f | angularRate ()
| Angular rate data. More...
bool | hasAngularRateUncompensated ()
| Indicates if `angularRateUncompensated` has valid data. More...
math::vec3f | angularRateUncompensated ()
| Angular rate uncompensated data. More...
bool | hasAnyTemperature ()
| Indicates if `anyTemperature` has valid data. More...
float | anyTemperature ()
| Gets and converts the latest temperature data regardless of the received underlying type. More...
bool | hasTemperature ()
| Indicates if `temperature` has valid data. More...
float | temperature ()
| Temperature data. More...
bool | hasAnyPressure ()
| Indicates if `anyPressure` has valid data. More...
float | anyPressure ()
| Gets and converts the latest pressure data regardless of the received underlying type. More...
bool | hasPressure ()
| Indicates if `pressure` has valid data. More...
float | pressure ()
| Pressure data. More...
bool | hasAnyPosition ()
| Indicates if `anyPosition` has valid data. More...
math::PositionD | anyPosition ()
| Gets the latest position data regardless of the received underlying type. More...
bool | hasPositionGpsLla ()
| Indicates if `positionGpsLla` has valid data. More...
math::vec3d | positionGpsLla ()
| Position GPS LLA data. More...
bool | hasPositionGpsEcef ()
| Indicates if `positionGpsEcef` has valid data. More...
math::vec3d | positionGpsEcef ()
| Position GPS ECEF data. More...
bool | hasPositionEstimatedLla ()
| Indicates if `positionEstimatedLla` has valid data. More...
math::vec3d | positionEstimatedLla ()
| Position Estimated LLA data. More...
bool | hasPositionEstimatedEcef ()
| Indicates if `positionEstimatedEcef` has valid data. More...
math::vec3d | positionEstimatedEcef ()
| Position Estimated ECEF data. More...
bool | hasAnyVelocity ()
| Indicates if `anyVelocity` has valid data. More...
math::vec3f | anyVelocity ()
| Gets the latest velocity data regardless of the received underlying type. More...
bool | hasVelocityGpsNed ()
| Indicates if `velocityGpsNed` has valid data. More...
math::vec3f | velocityGpsNed ()
| Velocity GPS NED data. More...
bool | hasVelocityGpsEcef ()
| Indicates if `velocityGpsEcef` has valid data. More...
math::vec3f | velocityGpsEcef ()
| Velocity GPS ECEF data. More...
bool | hasVelocityEstimatedNed ()
| Indicates if `velocityEstimatedNed` has valid data. More...
math::vec3f | velocityEstimatedNed ()
| Velocity Estimated NED data. More...
bool | hasVelocityEstimatedEcef ()
| Indicates if `velocityEstimatedEcef` has valid data. More...
math::vec3f | velocityEstimatedEcef ()
| Velocity Estimated ECEF data. More...
bool | hasVelocityEstimatedBody ()
| Indicates if `velocityEstimatedBody` has valid data. More...
math::vec3f | velocityEstimatedBody ()
| Velocity Estimated Body data. More...
bool | hasDeltaTime ()
| Indicates if `deltaTime` has valid data. More...
float | deltaTime ()
| Delta time data. More...
bool | hasDeltaTheta ()
| Indicates if `deltaTheta` has valid data. More...
math::vec3f | deltaTheta ()
| Delta theta data. More...
bool | hasDeltaVelocity ()
| Indicates if `deltaVelocity` has valid data. More...
math::vec3f | deltaVelocity ()
| Delta velocity data. More...
bool | hasTimeStartup ()
| Indicates if `timeStartup` has valid data. More...
uint64_t | timeStartup ()
| Time startup data. More...
bool | hasTimeGps ()
| Indicates if `timeGps` has valid data. More...
uint64_t | timeGps ()
| Time GPS data. More...
bool | hasTow ()
| Indicates if `tow` has valid data. More...
double | tow ()
| GPS time of week data. More...
bool | hasWeek ()
| Indicates if `week` has valid data. More...
uint16_t | week ()
| Week data. More...
bool | hasNumSats ()
| Indicates if `numSats` has valid data. More...
uint8_t | numSats ()
| NumSats data. More...
bool | hasTimeSyncIn ()
| Indicates if `timeSyncIn` has valid data. More...
uint64_t | timeSyncIn ()
| TimeSyncIn data. More...
bool | hasVpeStatus ()
| Indicates if `vpeStatus` has valid data. More...
protocol::uart::VpeStatus | vpeStatus ()
| VpeStatus data. More...
bool | hasInsStatus ()
| Indicates if `insStatus` has valid data. More...
protocol::uart::InsStatus | insStatus ()
| InsStatus data. More...
bool | hasSyncInCnt ()
| Indicates if `syncInCnt` has valid data. More...
uint32_t | syncInCnt ()
| SyncInCnt data. More...
bool | hasTimeGpsPps ()
| Indicates if `timeGpsPps` has valid data. More...
uint64_t | timeGpsPps ()
| TimeGpsPps data. More...
bool | hasGpsTow ()
| Indicates if `gpsTow` has valid data. More...
uint64_t | gpsTow ()
| GpsTow data. More...
bool | hasTimeUtc ()
| Indicates if `timeUtc` has valid data. More...
protocol::uart::TimeUtc | timeUtc ()
| TimeUtc data. More...
bool | hasSensSat ()
| Indicates if `sensSat` has valid data. More...
protocol::uart::SensSat | sensSat ()
| SensSat data. More...
bool | hasFix ()
| Indicates if `fix` has valid data. More...
protocol::uart::GpsFix | fix ()
| GPS fix data. More...
bool | hasAnyPositionUncertainty ()
| Indicates if `anyPositionUncertainty` has valid data. More...
math::vec3f | anyPositionUncertainty ()
| Gets the latest position uncertainty data regardless of the received underlying type. More...
bool | hasPositionUncertaintyGpsNed ()
| Indicates if `positionUncertaintyGpsNed` has valid data. More...
math::vec3f | positionUncertaintyGpsNed ()
| GPS position uncertainty NED data. More...
bool | hasPositionUncertaintyGpsEcef ()
| Indicates if `positionUncertaintyGpsEcef` has valid data. More...
math::vec3f | positionUncertaintyGpsEcef ()
| GPS position uncertainty ECEF data. More...
bool | hasPositionUncertaintyEstimated ()
| Indicates if `positionUncertaintyEstimated` has valid data. More...
float | positionUncertaintyEstimated ()
| Estimated position uncertainty data. More...
bool | hasAnyVelocityUncertainty ()
| Indicates if `anyVelocityUncertainty` has valid data. More...
float | anyVelocityUncertainty ()
| Gets the latest velocity uncertainty data regardless of the received underlying type. More...
bool | hasVelocityUncertaintyGps ()
| Indicates if `velocityUncertaintyGps` has valid data. More...
float | velocityUncertaintyGps ()
| GPS velocity uncertainty data. More...
bool | hasVelocityUncertaintyEstimated ()
| Indicates if `velocityUncertaintyEstimated` has valid data. More...
float | velocityUncertaintyEstimated ()
| Estimated velocity uncertainty data. More...
bool | hasTimeUncertainty ()
| Indicates if `timeUncertainty` has valid data. More...
uint32_t | timeUncertainty ()
| Time uncertainty data. More...
bool | hasAttitudeUncertainty ()
| Indicates if `attitudeUncertainty` has valid data. More...
math::vec3f | attitudeUncertainty ()
| Attitude uncertainty data. More...
bool | hasCourseOverGround ()
| Indicates if `courseOverGround` has valid data. More...
float | courseOverGround ()
| Computes the course over ground from any velocity data available. More...
bool | hasSpeedOverGround ()
| Indicates if `speedOverGround` has valid data. More...
float | speedOverGround ()
| Computes the speed over ground from any velocity data available. More...

## Static Public Member Functions

static CompositeData | parse (protocol::uart::Packet &p)
| Parses a packet. More...
static void | parse (protocol::uart::Packet &p, CompositeData &o)
| Parses a packet. More...
static void | parse (protocol::uart::Packet &p, std::vector< CompositeData * > &o)
| Parses a packet and updates multiple CompositeData objects. More...

## Detailed Description

Composite structure of all data types available from VectorNav sensors.

Examples:
  ez_async_data/main.cpp.

## Member Function Documentation

math::vec3f vn::sensors::CompositeData::acceleration | ( |  | ) |

Acceleration data.

Returns
  The acceleration data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::accelerationEcef | ( |  | ) |

Acceleration ECEF data.

Returns
  The acceleration ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::accelerationLinearBody | ( |  | ) |

Acceleration linear body data.

Returns
  The acceleration linear body data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::accelerationLinearEcef | ( |  | ) |

Acceleration linear ECEF data.

Returns
  The acceleration linear ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::accelerationLinearNed | ( |  | ) |

Acceleration linear NED data.

Returns
  The acceleration linear NED data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::accelerationNed | ( |  | ) |

Acceleration NED data.

Returns
  The acceleration NED data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::accelerationUncompensated | ( |  | ) |

Acceleration uncompensated data.

Returns
  The acceleration uncompensated data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::angularRate | ( |  | ) |

Angular rate data.

Returns
  The angular rate data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::angularRateUncompensated | ( |  | ) |

Angular rate uncompensated data.

Returns
  The angular rate uncompensated data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::anyAcceleration | ( |  | ) |

Gets and converts the latest acceleration data regardless of the received underlying type.

Returns
  The acceleration data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

math::vec3f vn::sensors::CompositeData::anyAngularRate | ( |  | ) |

Gets and converts the latest angular rate data regardless of the received underlying type.

Returns
  The angular rate data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

math::AttitudeF vn::sensors::CompositeData::anyAttitude | ( |  | ) |

Gets and converts the latest attitude data regardless of the received underlying type. Based on which type of attitude data that was last received and processed, this value may be based on either received yaw, pitch, roll, quaternion, or direction cosine matrix data.

Returns
  The attitude data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

Examples:
  ez_async_data/main.cpp.

math::vec3f vn::sensors::CompositeData::anyMagnetic | ( |  | ) |

Gets and converts the latest magnetic data regardless of the received underlying type. Based on which type of magnetic data that was last received and processed, this value may be based on either received magnetic or magneticUncompensated data.

Returns
  The magnetic data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

math::PositionD vn::sensors::CompositeData::anyPosition | ( |  | ) |

Gets the latest position data regardless of the received underlying type.

Returns
  The position data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

math::vec3f vn::sensors::CompositeData::anyPositionUncertainty | ( |  | ) |

Gets the latest position uncertainty data regardless of the received underlying type.

Returns
  The position uncertainty data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

float vn::sensors::CompositeData::anyPressure | ( |  | ) |

Gets and converts the latest pressure data regardless of the received underlying type.

Returns
  The pressure data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

float vn::sensors::CompositeData::anyTemperature | ( |  | ) |

Gets and converts the latest temperature data regardless of the received underlying type.

Returns
  The tempature data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

math::vec3f vn::sensors::CompositeData::anyVelocity | ( |  | ) |

Gets the latest velocity data regardless of the received underlying type.

Returns
  The velocity data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

float vn::sensors::CompositeData::anyVelocityUncertainty | ( |  | ) |

Gets the latest velocity uncertainty data regardless of the received underlying type.

Returns
  The velocity uncertainty data.

Exceptions

  invalid_operation | Thrown if there is no valid data.

math::vec3f vn::sensors::CompositeData::attitudeUncertainty | ( |  | ) |

Attitude uncertainty data.

Returns
  The attitude uncertainty data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::courseOverGround | ( |  | ) |

Computes the course over ground from any velocity data available.

Returns
  The computed course over ground.

Exceptions

  invalid_operation | Thrown if there is no valid data.

math::vec3f vn::sensors::CompositeData::deltaTheta | ( |  | ) |

Delta theta data.

Returns
  The delta theta data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::deltaTime | ( |  | ) |

Delta time data.

Returns
  The delta time data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::deltaVelocity | ( |  | ) |

Delta velocity data.

Returns
  The delta velocity data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::mat3f vn::sensors::CompositeData::directionCosineMatrix | ( |  | ) |

Direction cosine matrix data.

Returns
  Direction cosine matrix data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

protocol::uart::GpsFix vn::sensors::CompositeData::fix | ( |  | ) |

GPS fix data.

Returns
  The GPS fix data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint64_t vn::sensors::CompositeData::gpsTow | ( |  | ) |

GpsTow data.

Returns
  The GpsTow data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

bool vn::sensors::CompositeData::hasAcceleration | ( |  | ) |

Indicates if `acceleration` has valid data.

Returns
  `true` if `acceleration` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAccelerationEcef | ( |  | ) |

Indicates if `accelerationEcef` has valid data.

Returns
  `true` if `accelerationEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAccelerationLinearBody | ( |  | ) |

Indicates if `accelerationLinearBody` has valid data.

Returns
  `true` if `accelerationLinearBody` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAccelerationLinearEcef | ( |  | ) |

Indicates if `accelerationLinearEcef` has valid data.

Returns
  `true` if `accelerationLinearEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAccelerationLinearNed | ( |  | ) |

Indicates if `accelerationLinearNed` has valid data.

Returns
  `true` if `accelerationLinearNed` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAccelerationNed | ( |  | ) |

Indicates if `accelerationNed` has valid data.

Returns
  `true` if `accelerationNed` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAccelerationUncompensated | ( |  | ) |

Indicates if `accelerationUncompensated` has valid data.

Returns
  `true` if `accelerationUncompensated` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAngularRate | ( |  | ) |

Indicates if `angularRate` has valid data.

Returns
  `true` if `angularRate` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAngularRateUncompensated | ( |  | ) |

Indicates if `angularRateUncompensated` has valid data.

Returns
  `true` if `angularRateUncompensated` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyAcceleration | ( |  | ) |

Indicates if `anyAcceleration` has valid data.

Returns
  `true` if `anyAcceleration` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyAngularRate | ( |  | ) |

Indicates if `anyAngularRate` has valid data.

Returns
  `true` if `anyAngularRate` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyAttitude | ( |  | ) |

Indicates if `anyAttitude` has valid data.

Returns
  `true` if `anyAttitude` has valid data; otherwise `false`.

Examples:
  ez_async_data/main.cpp.

bool vn::sensors::CompositeData::hasAnyMagnetic | ( |  | ) |

Indicates if `anyMagnetic` has valid data.

Returns
  `true` if `anyMagnetic` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyPosition | ( |  | ) |

Indicates if `anyPosition` has valid data.

Returns
  `true` if `anyPosition` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyPositionUncertainty | ( |  | ) |

Indicates if `anyPositionUncertainty` has valid data.

Returns
  `true` if `anyPositionUncertainty` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyPressure | ( |  | ) |

Indicates if `anyPressure` has valid data.

Returns
  `true` if `anyPressure` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyTemperature | ( |  | ) |

Indicates if `anyTemperature` has valid data.

Returns
  `true` if `anyTemperature` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyVelocity | ( |  | ) |

Indicates if `anyVelocity` has valid data.

Returns
  `true` if `anyVelocity` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAnyVelocityUncertainty | ( |  | ) |

Indicates if `anyVelocityUncertainty` has valid data.

Returns
  `true` if `anyVelocityUncertainty` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasAttitudeUncertainty | ( |  | ) |

Indicates if `attitudeUncertainty` has valid data.

Returns
  `true` if `attitudeUncertainty` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasCourseOverGround | ( |  | ) |

Indicates if `courseOverGround` has valid data.

Returns
  `true` if `courseOverGround` havs valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasDeltaTheta | ( |  | ) |

Indicates if `deltaTheta` has valid data.

Returns
  `true` if `deltaTheta` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasDeltaTime | ( |  | ) |

Indicates if `deltaTime` has valid data.

Returns
  `true` if `deltaTime` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasDeltaVelocity | ( |  | ) |

Indicates if `deltaVelocity` has valid data.

Returns
  `true` if `deltaVelocity` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasDirectionCosineMatrix | ( |  | ) |

Indicates if `directionCosineMatrix` has valid data.

Returns
  `true` if `directionCosineMatrix` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasFix | ( |  | ) |

Indicates if `fix` has valid data.

Returns
  `true` if `fix` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasGpsTow | ( |  | ) |

Indicates if `gpsTow` has valid data.

Returns
  `true` if `gpsTow` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasInsStatus | ( |  | ) |

Indicates if `insStatus` has valid data.

Returns
  `true` if `insStatus` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasMagnetic | ( |  | ) |

Indicates if `magnetic` has valid data.

Returns
  `true` if `magnetic` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasMagneticEcef | ( |  | ) |

Indicates if `magneticEcef` has valid data.

Returns
  `true` if `magneticEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasMagneticNed | ( |  | ) |

Indicates if `magneticNed` has valid data.

Returns
  `true` if `magneticNed` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasMagneticUncompensated | ( |  | ) |

Indicates if `magneticUncompensated` has valid data.

Returns
  `true` if `magneticUncompensated` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasNumSats | ( |  | ) |

Indicates if `numSats` has valid data.

Returns
  `true` if `numSats` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPositionEstimatedEcef | ( |  | ) |

Indicates if `positionEstimatedEcef` has valid data.

Returns
  `true` if `positionEstimatedEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPositionEstimatedLla | ( |  | ) |

Indicates if `positionEstimatedLla` has valid data.

Returns
  `true` if `positionEstimatedLla` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPositionGpsEcef | ( |  | ) |

Indicates if `positionGpsEcef` has valid data.

Returns
  `true` if `positionGpsEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPositionGpsLla | ( |  | ) |

Indicates if `positionGpsLla` has valid data.

Returns
  `true` if `positionGpsLla` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPositionUncertaintyEstimated | ( |  | ) |

Indicates if `positionUncertaintyEstimated` has valid data.

Returns
  `true` if `positionUncertaintyEstimated` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPositionUncertaintyGpsEcef | ( |  | ) |

Indicates if `positionUncertaintyGpsEcef` has valid data.

Returns
  `true` if `positionUncertaintyGpsEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPositionUncertaintyGpsNed | ( |  | ) |

Indicates if `positionUncertaintyGpsNed` has valid data.

Returns
  `true` if `positionUncertaintyGpsNed` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasPressure | ( |  | ) |

Indicates if `pressure` has valid data.

Returns
  `true` if `pressure` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasQuaternion | ( |  | ) |

Indicates if `quaternion` has valid data.

Returns
  `true` if `quaternion` has valid data; otherwise `false`.

Examples:
  ez_async_data/main.cpp.

bool vn::sensors::CompositeData::hasSensSat | ( |  | ) |

Indicates if `sensSat` has valid data.

Returns
  `true` if `sensSat` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasSpeedOverGround | ( |  | ) |

Indicates if `speedOverGround` has valid data.

Returns
  `true` if `speedOverGround` havs valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasSyncInCnt | ( |  | ) |

Indicates if `syncInCnt` has valid data.

Returns
  `true` if `syncInCnt` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTemperature | ( |  | ) |

Indicates if `temperature` has valid data.

Returns
  `true` if `temperature` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTimeGps | ( |  | ) |

Indicates if `timeGps` has valid data.

Returns
  `true` if `timeGps` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTimeGpsPps | ( |  | ) |

Indicates if `timeGpsPps` has valid data.

Returns
  `true` if `timeGpsPps` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTimeStartup | ( |  | ) |

Indicates if `timeStartup` has valid data.

Returns
  `true` if `timeStartup` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTimeSyncIn | ( |  | ) |

Indicates if `timeSyncIn` has valid data.

Returns
  `true` if `timeSyncIn` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTimeUncertainty | ( |  | ) |

Indicates if `timeUncertainty` has valid data.

Returns
  `true` if `timeUncertainty` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTimeUtc | ( |  | ) |

Indicates if `timeUtc` has valid data.

Returns
  `true` if `timeUtc` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasTow | ( |  | ) |

Indicates if `tow` has valid data.

Returns
  `true` if `tow` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVelocityEstimatedBody | ( |  | ) |

Indicates if `velocityEstimatedBody` has valid data.

Returns
  `true` if `velocityEstimatedBody` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVelocityEstimatedEcef | ( |  | ) |

Indicates if `velocityEstimatedEcef` has valid data.

Returns
  `true` if `velocityEstimatedEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVelocityEstimatedNed | ( |  | ) |

Indicates if `velocityEstimatedNed` has valid data.

Returns
  `true` if `velocityEstimatedNed` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVelocityGpsEcef | ( |  | ) |

Indicates if `velocityGpsEcef` has valid data.

Returns
  `true` if `velocityGpsEcef` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVelocityGpsNed | ( |  | ) |

Indicates if `velocityGpsNed` has valid data.

Returns
  `true` if `velocityGpsNed` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVelocityUncertaintyEstimated | ( |  | ) |

Indicates if `velocityUncertaintyEstimated` has valid data.

Returns
  `true` if `velocityUncertaintyEstimated` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVelocityUncertaintyGps | ( |  | ) |

Indicates if `velocityUncertaintyGps` has valid data.

Returns
  `true` if `velocityUncertaintyGps` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasVpeStatus | ( |  | ) |

Indicates if `vpeStatus` has valid data.

Returns
  `true` if `vpeStatus` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasWeek | ( |  | ) |

Indicates if `week` has valid data.

Returns
  `true` if `week` has valid data; otherwise `false`.

bool vn::sensors::CompositeData::hasYawPitchRoll | ( |  | ) |

Indicates if `yawPitchRoll` has valid data.

Returns
  `true` if `yawPitchRoll` has valid data; otherwise `false`.

Examples:
  ez_async_data/main.cpp.

protocol::uart::InsStatus vn::sensors::CompositeData::insStatus | ( |  | ) |

InsStatus data.

Returns
  The InsStatus data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::magnetic | ( |  | ) |

Magnetic data.

Returns
  The magnetic data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::magneticEcef | ( |  | ) |

Magnetic ECEF data.

Returns
  The magnetic ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::magneticNed | ( |  | ) |

Magnetic NED data.

Returns
  The magnetic NED data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::magneticUncompensated | ( |  | ) |

Magnetic uncompensated data.

Returns
  The magnetic uncompensated data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint8_t vn::sensors::CompositeData::numSats | ( |  | ) |

NumSats data.

Returns
  The numsats data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

static CompositeData vn::sensors::CompositeData::parse | ( | protocol::uart::Packet & | p | ) |

static

Parses a packet.

Parameters

  [in] | p | The packet to parse.

Returns
  The data contained in the parsed packet.

static void vn::sensors::CompositeData::parse | ( | protocol::uart::Packet & | p,
|  | CompositeData & | o
| ) |  |

static

Parses a packet.

Parameters

  [in] | p | The packet to parse.

static void vn::sensors::CompositeData::parse | ( | protocol::uart::Packet & | p,
|  | std::vector< CompositeData * > & | o
| ) |  |

static

Parses a packet and updates multiple CompositeData objects.

Parameters

  [in] | p | The packet to parse.
  [in] | o | The collection of CompositeData objects to update.

math::vec3d vn::sensors::CompositeData::positionEstimatedEcef | ( |  | ) |

Position Estimated ECEF data.

Returns
  The Position Estimated ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3d vn::sensors::CompositeData::positionEstimatedLla | ( |  | ) |

Position Estimated LLA data.

Returns
  The Position Estimated LLA data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3d vn::sensors::CompositeData::positionGpsEcef | ( |  | ) |

Position GPS ECEF data.

Returns
  The Position GPS ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3d vn::sensors::CompositeData::positionGpsLla | ( |  | ) |

Position GPS LLA data.

Returns
  The Position GPS LLA data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::positionUncertaintyEstimated | ( |  | ) |

Estimated position uncertainty data.

Returns
  The estimated position uncertainty data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::positionUncertaintyGpsEcef | ( |  | ) |

GPS position uncertainty ECEF data.

Returns
  The GPS position uncertainty ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::positionUncertaintyGpsNed | ( |  | ) |

GPS position uncertainty NED data.

Returns
  The GPS position uncertainty NED data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::pressure | ( |  | ) |

Pressure data.

Returns
  The pressure data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec4f vn::sensors::CompositeData::quaternion | ( |  | ) |

Quaternion data.

Returns
  Quaternion data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

protocol::uart::SensSat vn::sensors::CompositeData::sensSat | ( |  | ) |

SensSat data.

Returns
  The SensSat data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::speedOverGround | ( |  | ) |

Computes the speed over ground from any velocity data available.

Returns
  The computed speed over ground.

Exceptions

  invalid_operation | Thrown if there is no valid data.

uint32_t vn::sensors::CompositeData::syncInCnt | ( |  | ) |

SyncInCnt data.

Returns
  The SyncInCnt data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::temperature | ( |  | ) |

Temperature data.

Returns
  The temperature data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint64_t vn::sensors::CompositeData::timeGps | ( |  | ) |

Time GPS data.

Returns
  The time GPS data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint64_t vn::sensors::CompositeData::timeGpsPps | ( |  | ) |

TimeGpsPps data.

Returns
  The TimeGpsPps data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint64_t vn::sensors::CompositeData::timeStartup | ( |  | ) |

Time startup data.

Returns
  The time startup data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint64_t vn::sensors::CompositeData::timeSyncIn | ( |  | ) |

TimeSyncIn data.

Returns
  The TimeSyncIn data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint32_t vn::sensors::CompositeData::timeUncertainty | ( |  | ) |

Time uncertainty data.

Returns
  The time uncertainty data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

protocol::uart::TimeUtc vn::sensors::CompositeData::timeUtc | ( |  | ) |

TimeUtc data.

Returns
  The TimeUtc data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

double vn::sensors::CompositeData::tow | ( |  | ) |

GPS time of week data.

Returns
  The GPS time of week data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::velocityEstimatedBody | ( |  | ) |

Velocity Estimated Body data.

Returns
  The velocity estimated body data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::velocityEstimatedEcef | ( |  | ) |

Velocity Estimated ECEF data.

Returns
  The velocity estimated ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::velocityEstimatedNed | ( |  | ) |

Velocity Estimated NED data.

Returns
  The velocity estimated NED data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::velocityGpsEcef | ( |  | ) |

Velocity GPS ECEF data.

Returns
  The velocity GPS ECEF data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::velocityGpsNed | ( |  | ) |

Velocity GPS NED data.

Returns
  The velocity GPS NED data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::velocityUncertaintyEstimated | ( |  | ) |

Estimated velocity uncertainty data.

Returns
  The estimated velocity uncertainty data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

float vn::sensors::CompositeData::velocityUncertaintyGps | ( |  | ) |

GPS velocity uncertainty data.

Returns
  The GPS velocity uncertainty data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

protocol::uart::VpeStatus vn::sensors::CompositeData::vpeStatus | ( |  | ) |

VpeStatus data.

Returns
  The VpeStatus data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

uint16_t vn::sensors::CompositeData::week | ( |  | ) |

Week data.

Returns
  The week data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

math::vec3f vn::sensors::CompositeData::yawPitchRoll | ( |  | ) |

Yaw, pitch, roll data.

Returns
  The yaw, pitch, roll data.

Exceptions

  invalid_operation | Thrown if there is not any valid data.

Examples:
  ez_async_data/main.cpp.

The documentation for this class was generated from the following file:

- include/vn/compositedata.h